Title: Building a 5 node Proxmox cluster!
Date: 2024-07-24 20:00
Modified: 2024-07-24 20:00
Category: Server Architecture
Tags: proxmox, kubernetes, hardware
Slug: proxmox-cluster-1
Authors: Andrew Ridgway
Summary: Upgrade from a small docker-compose style server to full proxmox server with kubernetes, LXC, and a hypervisor

## A Picture is worth a thousand words
<INSERT PICTURE HERE OF FINAL PRODUCT>

## The idea
For some time now I have been toying with the idea of a hypervisor. Initially my thoughts were to get some old blade servers and use those. That was until someone pointed out there power requirements. Looking at specs for some of these machines the power supplies would be 600 to 800 watts, which is fine until you realise that these have redundant powersupplies and are now potentially pulling up 1.5kW of energy... I'm not made of money!

I eventually decided I'd use some hardware I had already lying around, including the old server, as well as 3 Old Intel Nuc I could pick up for under $100 (4th gen core i5's upgraded to 16GB RAM DDR3). I'd also use an old Dell Workstation I had lying around to provide space for some storage, it currently has 4TB RAID 1 on BTRFS sharing via NFS.

All together the 5 machines draw less that 600W of power, cool, hardware sorted (at least for a little hobby cluster)

### The platform for the Idea!
After doing some amazing reddit research and looking at various homelab ideas for doing what I wanted it became very very clear the proxmx was going to the solution. Its a debian based, open source hypervisor that, for the cost of an annoying little nag when you log in and some manual deb repo congif, gives you an enterprise grade hypervisor ready to spin up VM's and "LXC's" or Linux Jails...These have turned out to be really really useful but more on that later.
